## Script (Python) "getFiltredMailList"
##parameters=filter=None, sorting_param='identifier', sort_order='desc'
#$Id: getFilteredMailList.py,v 1.1.1.1 2004/03/12 10:33:34 anguenot Exp $

"""Returns the list of mailfolders

filter correponds to a review_state.
sorting_param corresponds to the way the mailfolder list is sorted.
"""

#
# MAILFOLDER EXISTING TYPES
# XXX PSIv2 (next version)
# Add the two new mailfolder types.
#

MAIL_FOLDER_PORTAL_TYPES = ['InComingMailFolder', 'SpontaneousMailFolder']

#
# QUERY CATALOG IN HERE FOR MAILFOLDERS
#

mail_list = context.search(query={'path':'context.absolute_url()',
                                  'portal_type':MAIL_FOLDER_PORTAL_TYPES})

#
# SORTING MAILFOLDER LIST AGAINST FILTERS
#

if sorting_param is not None:
    mail_list = context.sortMailFolderProxyList(mail_list, sorting_param, sort_order)

#
# FILTERING ON REVIEW_STATE AND/OR ACTOR ROLES
#

if filter == "all":
    return [x for x in mail_list
            if x.getContentInfo(x,
                                doc=x.getContent())['review_state']
                                != "closed"]
elif filter =="to_handle":
    return [x for x in mail_list
            if x.getContentInfo(x,
                                doc=x.getContent())['review_state']
                                not in['validating', 'closed']]
elif filter == "to_validate":
    return [x for x in mail_list
            if x.getContentInfo(x,
                                doc=x.getContent())['review_state']
                                == "validating"]
elif filter == 'closed':
    return [x for x in mail_list
            if x.getContentInfo(x,
                                doc=x.getContent())['review_state']
                                == "closed"]
elif filter == "to_work_on_it":
    return [x for x in mail_list
            if 'Associate' in x.getContent().getCurrentMemberRoles()]
elif filter =="to_watch":
    return [x for x in mail_list
            if 'Watcher' in x.getContent().getCurrentMemberRoles()]
else:
    return []
